/*
 * 7SEG LED4 n[hEFASPI_Ci~bNXLTvitimer0gpj@Version 1.00
 * File:        7seg4c3c.c
 * Target:      PIC18F46K22 64MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2014/02/07 19:20
 * MSPP2W[SPĨf[^쐬 74HC595ɐڑꂽLED00009999܂1JEgȂ\B\^C~Otimer0ɂ銄荞݂gp
 * ڑ
 *   SCK2(RD0),SDO2(RD4),SS2(RD3)
 * LED̃f[^tH[}bg
 *   MSB xxxxdddd LSB
 *   xxxx͊erbgʒuɑΉ(Lœ_)
 *   dddd͌f[^
*/

#include <p18f46k22.h>
#include <plib\delays.h>
#include <plib\spi.h>

#pragma config  FOSC = HSHP,PRICLKEN=ON,PLLCFG=ON,WDTEN=OFF,LVP=OFF

#define SCK PORTDbits.RD0
#define SS  PORTDbits.RD3
#define SDO PORTDbits.RD4

char SPI2rw(char w);            //  SPI2o
void interrupt isr(void);       //  1msů荞ݏ[`
void disp_7seg(unsigned w);    //  W10iƂ݂Ȃ7SEG\f[^ݒ
void disp_7seg_hex(unsigned w);//  W16iƂ݂Ȃ7SEG\f[^ݒ

unsigned char disp7seg_data[4];  // \f[^4
unsigned char disp7seg_count=0;  // \ʒu

void main(void){
    ANSELDbits.ANSD0=0; //  SCK2
    ANSELDbits.ANSD3=0; //  SS2
    ANSELDbits.ANSD4=0; //  SDO2
    SS=0;
    SCK=0;
    SDO=0;
    TRISDbits.RD3=0;
    TRISDbits.RD0=0;
    TRISDbits.RD4=0;

    OpenSPI2(SPI_FOSC_16,MODE_11,SMPMID);
    SPI2rw(0xff);   // LED
//  1msɐݒ
    OpenTimer0(TIMER_INT_ON & T0_8BIT & T0_SOURCE_INT & T0_PS_1_128);
    WriteTimer0(131);

    INTCONbits.TMR0IE=1;
    INTCONbits.GIE=1;

    for(;;)
       for(unsigned n=0;n<10000;n++){
            disp_7seg(n);
            Delay10KTCYx( 250); // 64MHz/4*0.16b/10000
        }
}

//  1msů荞ݏ[`

void interrupt isr(void){
    INTCONbits.TMR0IF=0;

    if(disp7seg_count>3)
        disp7seg_count=0;

    SPI2rw(disp7seg_data[disp7seg_count]);
    ++disp7seg_count;
    WriteTimer0(131);
}

//  SPI2o

char SPI2rw(char w){
    SS=0;
    SSP2BUF=w;
    while(!SSP2STATbits.BF);
    char r=SSP2BUF;
    SS=1;
    return r;
}

//  W10iƂ݂Ȃ7SEG\f[^ݒ

void disp_7seg(unsigned w){
    unsigned d;
    d=w % 10;
    disp7seg_data[3]=0xe0+d;   //  1

    d=(w/10) % 10;
    disp7seg_data[2]=0xd0+d;   //  2

    d=(w/100) % 10;
    disp7seg_data[1]=0xb0+d;   //  3

    d=(w/1000) % 10;
    disp7seg_data[0]=0x70+d;   //  4
}

//  W16iƂ݂Ȃ7SEG\f[^ݒ

void disp_7_hex(unsigned w){
    unsigned d;
    d=w & 0x0f;
    disp7seg_data[3]=0xe0+d;   //  1

    d=(w>>4) & 0xf;
    disp7seg_data[2]=0xd0+d;   //  2

    d=(w>>8) & 0xf;
    disp7seg_data[1]=0xb0+d;   //  3

    d=(w>>12) & 0xf;
    disp7seg_data[0]=0x70+d;   //  4
}
